%We assume that the left and the right cameras are calibrated with known intrinsic
%and extrinsic matrices. We read intrinsic (Mi_L, and Mi_R= and extrinsic matrices (Me_L and Me_R) of 
%the left and the right cameras from the file MiMe  by execution.
MiMe

%That i) t_L and t_R are NOW in camera coordinates pointing into world origin (after sign change), 
%and ii) R_L and R_R transfer NOW  from world to camera coordinates 
%are verified by debugging and development lines further below... in
%combination with distance/size calculations of familiar objects in left
%and  right pictures.


%Assuming having the right hypothesis on inter coordinateframe growth directions...we
%can confidently write stereo parameters where left-camera frame takes on the role of the world
%according to eq. 13.89, 13.88....
%Consequently, please FILL IN THE FOLLOWING CODE LINES...

aa=0; %dummy assignment to enable a break point.

R= ; %please FILL IN...
t= ; %please FILL IN...
Me= ; %please FILL IN...


%Triangulation applied to image points from two images (with pre-established correspondances)...
%...we read point pairs from point_pairs.m by execution.
point_pairs1;  
fh=figure(1);ImLeft=imread('left.bmp'); %and show images...
imshow(ImLeft);%...
plotpts(fh,ppl,'o','g') %as well as labeled points having correspondences  
fh=figure(2);ImRight=imread('right.bmp'); %...
imshow(ImRight); %...
plotpts(fh,ppr,'o','r') %...


% %For manual adjustment of corresponding points...
% h = cpselect(ImLeft,ImRight,ppl,ppr);
%

for idp=1:size(ppr,1)
 %We apply eq. 13.85 to pairs of points from left and right cameras using
 %the triangulation algorithm in pp2p...The result must include the depth
 %coordinat Z_C expressed in the left camera beside X_C and Y_C
 P(idp,:)=pp2p(ppl(idp,:), ppr(idp,:),Mi_L,Mi_R,Me)'; %open the file pp2p.m and COMPLETE IT according to its description at the beginning.  
end;

%Verification of obtained 3D cooordinates, 
%with left-right image points correspondances assumed to have been done manually (by clicking) ahead of the time.
Drc3=P(4,:)-P(5,:);Rubic3=norm(Drc3) %Side of rubic cube (with 3x3 squares) in mm. Ground truth 56 mm for standard rubic cube
%https://en.wikipedia.org/wiki/Rubik%27s_Cube
Drc4=P(1,:)-P(2,:);Rubic4=norm(Drc4) %Side of rubic cube (with 4x4 squares) in mm. There seems to be more variations...A common version seems to be 62-63 mm...
%https://www.reddit.com/r/Cubers/comments/908k5s/the_shrinking_cube_trend_whats_the_perfect_size/
Dha4=P(6,:)-P(7,:);height_a4=norm(Dha4) %height of box for  A4 paper in mm
df_ball_Naive=norm(P(12,:)-P(13,:)) %First estimate of the Diameter of the football in stereo image pair. Naive Trial.
%The diameter of standard (size 5) football is between 218-221mm 
%whereas a "size 4"  football is between "202-210mm" ...
%There can be a problem in our assumption...because it may be that the
%3D point P(12,:) may  not be visible in both images due to camera rotation
%angles which might differ. This would prompt that image points which we thought corresponded P(12,:), actually donot, resulting in measurement error.
%The same goes for P(13,:). image correspondances of P(13,:)  may contain errors. 
%Below, we attempt to find the ball diameter from distances between
%pentagon centers P(9:11,:). 

Sp=mean([norm(P(9,:)-P(10,:)), norm(P(10,:)-P(11,:)), norm(P(9,:)-P(11,:))]);  %average distance between pentagons on our football...
Spt=1.051462224238267; %Theoretical side when radius of a ball is 1 unit, i.e.  mm here.  The value Spt is calculated as follows, 
%sinb= 2/sqrt(5);cosb= 1/sqrt(5);  Spt=norm([sinb, cosb,0]-[sinb*cos(pi*72/180), cosb, sinb*sin(pi*72/180)]);see...
%http://www.hoist-point.com/soccerball.htm or the corresponding pdf file here...
df_ball=Sp/Spt;  %This is then the radius of our football in mm, using the similarity/scaleing principle in Geometry.
df_ball=2*df_ball %...The diameter of our ball.
%The diameter of our ball would change of course, but only  a few
%milimeters depending on which pentagons we choose
% Sp=mean([norm(P(9,:)-P(10,:)), norm(P(10,:)-P(11,:)), norm(P(9,:)-P(11,:)),norm(P(9,:)-P(14,:)),norm(P(14,:)-P(11,:))]);  
% Sp=mean([ norm(P(9,:)-P(11,:)),norm(P(9,:)-P(14,:)),norm(P(14,:)-P(11,:))]);  
%...So  the football is not standard size. It is likely size-4 ball, or  a toy, wanna-be football (where pentagons and 
%hexagons are painted on plastic/rubber made football).
